import { IFunctionScanResult } from './types';
import { ScriptNode } from '../parser/types';
import { TreeTraverse } from '../parser/treeTraverse';
/**
 * Class to help identify parameters and return statements in
 * a kerboscript function
 */
export declare class FunctionScan extends TreeTraverse {
    /**
     * result of the scan
     */
    private result;
    /**
     * Function scan constructor
     */
    constructor();
    /**
     * Scan the function node for parameters and return statements
     * @param node function body
     */
    scan(node: ScriptNode): IFunctionScanResult;
    /**
     * Action to apply at each node traversed
     * @param node node in question
     */
    protected nodeAction(node: ScriptNode): boolean;
}
