import { SymbolTrackerBase, IKsDeclared, TrackerKind } from './types';
import { KsSuffix } from '../entities/suffix';
import { Location } from 'vscode-languageserver';
import { ISuffixType } from '../typeChecker/types/types';
export declare class SuffixTracker implements SymbolTrackerBase<KsSuffix> {
    type: ISuffixType;
    declared: IKsDeclared<KsSuffix, ISuffixType>;
    constructor(symbol: KsSuffix, type: ISuffixType);
    /**
     * Get the the type of the suffix type
     * @param _ location is irrelvant since suffix types cannot be changed
     */
    getType(_: Location): ISuffixType;
    /**
     * What kind of tracker is this type
     */
    readonly kind: TrackerKind.suffix;
}
