"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const vscode_languageserver_1 = require("vscode-languageserver");
const constants_1 = require("../utilities/constants");
class SuffixTracker {
    constructor(symbol, type) {
        this.type = type;
        this.declared = {
            symbol,
            type,
            uri: constants_1.builtIn,
            range: vscode_languageserver_1.Range.create(vscode_languageserver_1.Position.create(0, 0), vscode_languageserver_1.Position.create(0, 0)),
        };
    }
    /**
     * Get the the type of the suffix type
     * @param _ location is irrelvant since suffix types cannot be changed
     */
    getType(_) {
        return this.declared.type;
    }
    /**
     * What kind of tracker is this type
     */
    get kind() {
        return 1 /* suffix */;
    }
}
exports.SuffixTracker = SuffixTracker;
//# sourceMappingURL=suffixTracker.js.map