import { ScopeKind } from '../parser/types';
import { KsSymbolKind } from '../analysis/types';
import { Token } from './token';
/**
 * A class containing the information of a function
 */
export declare class KsFunction {
    readonly scope: ScopeKind;
    readonly name: Token;
    readonly requiredParameters: number;
    readonly optionalParameters: number;
    readonly returnValue: boolean;
    /**
     * A kerboscript function constructor
     * @param scope the scope of this variable
     * @param name the name of this variable
     * @param requiredParameters the number of required parameters
     * @param optionalParameters the number of optional parameters
     * @param returnValue does the function return a value
     */
    constructor(scope: ScopeKind, name: Token, requiredParameters: number, optionalParameters: number, returnValue: boolean);
    /**
     * What kind of symbol is represented in this case a parameter
     */
    readonly tag: KsSymbolKind.function;
}
