"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const types_1 = require("../analysis/types");
/**
 * A class containing the information of a function
 */
class KsFunction {
    /**
     * A kerboscript function constructor
     * @param scope the scope of this variable
     * @param name the name of this variable
     * @param requiredParameters the number of required parameters
     * @param optionalParameters the number of optional parameters
     * @param returnValue does the function return a value
     */
    constructor(scope, name, requiredParameters, optionalParameters, returnValue) {
        this.scope = scope;
        this.name = name;
        this.requiredParameters = requiredParameters;
        this.optionalParameters = optionalParameters;
        this.returnValue = returnValue;
    }
    /**
     * What kind of symbol is represented in this case a parameter
     */
    get tag() {
        return types_1.KsSymbolKind.function;
    }
}
exports.KsFunction = KsFunction;
//# sourceMappingURL=function.js.map