import { ScopeKind } from '../parser/types';
import { KsSymbolKind } from '../analysis/types';
import { Token } from './token';
/**
 * A class containing the information of a lock
 */
export declare class KsLock {
    readonly scope: ScopeKind;
    readonly name: Token;
    /**
     * A kerboscript lock constructor
     * @param scope the scope of this lock
     * @param name the name of this lock
     */
    constructor(scope: ScopeKind, name: Token);
    /**
     * Is this lock "cooked"
     */
    readonly cooked: boolean;
    /**
     * What kind of symbol is represented in this case a lock
     */
    readonly tag: KsSymbolKind.lock;
}
