"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const types_1 = require("../analysis/types");
/**
 * A class containing the information of a lock
 */
class KsLock {
    /**
     * A kerboscript lock constructor
     * @param scope the scope of this lock
     * @param name the name of this lock
     */
    constructor(scope, name) {
        this.scope = scope;
        this.name = name;
    }
    /**
     * Is this lock "cooked"
     */
    get cooked() {
        switch (this.name.lookup) {
            case 'throttle':
            case 'steering':
            case 'wheelthrottle':
            case 'wheelsteering':
                return true;
            default:
                return false;
        }
    }
    /**
     * What kind of symbol is represented in this case a lock
     */
    get tag() {
        return types_1.KsSymbolKind.lock;
    }
}
exports.KsLock = KsLock;
//# sourceMappingURL=lock.js.map