"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Implementation of vscode position interface
 */
class Marker {
    constructor(line, character) {
        this.line = line;
        this.character = character;
    }
}
exports.Marker = Marker;
/**
 * A mutable implementation of vscode's position interface
 */
class MutableMarker {
    constructor(line, character) {
        this.line = line;
        this.character = character;
    }
    /**
     * Create an immutable marker from this mutable marker
     */
    toImmutable() {
        return new Marker(this.line, this.character);
    }
}
exports.MutableMarker = MutableMarker;
//# sourceMappingURL=marker.js.map