import { IStmt, IScript, RunStmtType, SyntaxKind } from '../parser/types';
import { Range, Position, Location } from 'vscode-languageserver';
import { NodeBase } from '../parser/base';
export declare class Script extends NodeBase implements IScript {
    readonly uri: string;
    readonly stmts: IStmt[];
    readonly runStmts: RunStmtType[];
    lazyGlobal: boolean;
    constructor(uri: string, stmts: IStmt[], runStmts: RunStmtType[], lazyGlobal?: boolean);
    toLines(): string[];
    readonly start: Position;
    readonly end: Position;
    readonly ranges: Range[];
    toLocation(): Location;
    readonly tag: SyntaxKind.script;
}
