import { TokenType } from './tokentypes';
import { Range, Position } from 'vscode-languageserver';
import { TokenBase } from './types';
import { SymbolTracker } from '../analysis/types';
/**
 * Represents  an atomic unit of the kerboscript language
 */
export declare class Token implements TokenBase {
    readonly type: TokenType;
    readonly lexeme: string;
    readonly literal: any;
    readonly start: Position;
    readonly end: Position;
    readonly uri: string;
    /**
     * What symbol tracker is this token tied too
     */
    tracker: Maybe<SymbolTracker>;
    constructor(type: TokenType, lexeme: string, literal: any, start: Position, end: Position, uri: string);
    /**
     * A lowercase version of the lexeme for case insenstive comparisions
     */
    readonly lookup: string;
    readonly tag: 'token';
    readonly typeString: string;
    readonly range: Range;
    /**
     * Convert the token to a human readable string
     */
    toString(): string;
}
