"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tokentypes_1 = require("./tokentypes");
/**
 * Represents  an atomic unit of the kerboscript language
 */
class Token {
    constructor(type, lexeme, literal, start, end, uri) {
        this.type = type;
        this.lexeme = lexeme;
        this.literal = literal;
        this.start = start;
        this.end = end;
        this.uri = uri;
        this.tracker = undefined;
    }
    /**
     * A lowercase version of the lexeme for case insenstive comparisions
     */
    get lookup() {
        return this.lexeme.toLowerCase();
    }
    get tag() {
        return 'token';
    }
    get typeString() {
        return tokentypes_1.TokenType[this.type];
    }
    get range() {
        return {
            start: this.start,
            end: this.end,
        };
    }
    /**
     * Convert the token to a human readable string
     */
    toString() {
        if (this.literal) {
            return `${this.typeString} ${this.lexeme} ${this.literal}`;
        }
        return `${this.typeString} ${this.lexeme}`;
    }
}
exports.Token = Token;
//# sourceMappingURL=token.js.map