"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var TokenType;
(function (TokenType) {
    // whitespace
    TokenType[TokenType["whiteSpace"] = 0] = "whiteSpace";
    TokenType[TokenType["commentLine"] = 1] = "commentLine";
    TokenType[TokenType["plus"] = 2] = "plus";
    TokenType[TokenType["minus"] = 3] = "minus";
    TokenType[TokenType["multi"] = 4] = "multi";
    TokenType[TokenType["div"] = 5] = "div";
    TokenType[TokenType["power"] = 6] = "power";
    TokenType[TokenType["not"] = 7] = "not";
    TokenType[TokenType["and"] = 8] = "and";
    TokenType[TokenType["or"] = 9] = "or";
    TokenType[TokenType["true"] = 10] = "true";
    TokenType[TokenType["false"] = 11] = "false";
    TokenType[TokenType["equal"] = 12] = "equal";
    TokenType[TokenType["notEqual"] = 13] = "notEqual";
    TokenType[TokenType["greaterEqual"] = 14] = "greaterEqual";
    TokenType[TokenType["greater"] = 15] = "greater";
    TokenType[TokenType["lessEqual"] = 16] = "lessEqual";
    TokenType[TokenType["less"] = 17] = "less";
    TokenType[TokenType["set"] = 18] = "set";
    TokenType[TokenType["unset"] = 19] = "unset";
    TokenType[TokenType["to"] = 20] = "to";
    TokenType[TokenType["is"] = 21] = "is";
    TokenType[TokenType["until"] = 22] = "until";
    TokenType[TokenType["if"] = 23] = "if";
    TokenType[TokenType["else"] = 24] = "else";
    TokenType[TokenType["for"] = 25] = "for";
    TokenType[TokenType["when"] = 26] = "when";
    TokenType[TokenType["then"] = 27] = "then";
    TokenType[TokenType["from"] = 28] = "from";
    TokenType[TokenType["do"] = 29] = "do";
    TokenType[TokenType["at"] = 30] = "at";
    TokenType[TokenType["on"] = 31] = "on";
    TokenType[TokenType["in"] = 32] = "in";
    TokenType[TokenType["lock"] = 33] = "lock";
    TokenType[TokenType["unlock"] = 34] = "unlock";
    TokenType[TokenType["print"] = 35] = "print";
    TokenType[TokenType["arrayIndex"] = 36] = "arrayIndex";
    TokenType[TokenType["integer"] = 37] = "integer";
    TokenType[TokenType["double"] = 38] = "double";
    TokenType[TokenType["string"] = 39] = "string";
    TokenType[TokenType["local"] = 40] = "local";
    TokenType[TokenType["global"] = 41] = "global";
    TokenType[TokenType["parameter"] = 42] = "parameter";
    TokenType[TokenType["function"] = 43] = "function";
    TokenType[TokenType["preserve"] = 44] = "preserve";
    TokenType[TokenType["break"] = 45] = "break";
    TokenType[TokenType["return"] = 46] = "return";
    TokenType[TokenType["declare"] = 47] = "declare";
    TokenType[TokenType["defined"] = 48] = "defined";
    // done
    TokenType[TokenType["bracketOpen"] = 49] = "bracketOpen";
    TokenType[TokenType["bracketClose"] = 50] = "bracketClose";
    TokenType[TokenType["curlyOpen"] = 51] = "curlyOpen";
    TokenType[TokenType["curlyClose"] = 52] = "curlyClose";
    TokenType[TokenType["squareOpen"] = 53] = "squareOpen";
    TokenType[TokenType["squareClose"] = 54] = "squareClose";
    TokenType[TokenType["comma"] = 55] = "comma";
    TokenType[TokenType["colon"] = 56] = "colon";
    TokenType[TokenType["period"] = 57] = "period";
    TokenType[TokenType["atSign"] = 58] = "atSign";
    TokenType[TokenType["eof"] = 59] = "eof";
    TokenType[TokenType["toggle"] = 60] = "toggle";
    TokenType[TokenType["wait"] = 61] = "wait";
    TokenType[TokenType["off"] = 62] = "off";
    TokenType[TokenType["list"] = 63] = "list";
    TokenType[TokenType["clearscreen"] = 64] = "clearscreen";
    TokenType[TokenType["stage"] = 65] = "stage";
    TokenType[TokenType["add"] = 66] = "add";
    TokenType[TokenType["remove"] = 67] = "remove";
    TokenType[TokenType["log"] = 68] = "log";
    TokenType[TokenType["step"] = 69] = "step";
    TokenType[TokenType["switch"] = 70] = "switch";
    TokenType[TokenType["copy"] = 71] = "copy";
    TokenType[TokenType["rename"] = 72] = "rename";
    TokenType[TokenType["volume"] = 73] = "volume";
    TokenType[TokenType["file"] = 74] = "file";
    TokenType[TokenType["delete"] = 75] = "delete";
    TokenType[TokenType["edit"] = 76] = "edit";
    TokenType[TokenType["all"] = 77] = "all";
    TokenType[TokenType["run"] = 78] = "run";
    TokenType[TokenType["runPath"] = 79] = "runPath";
    TokenType[TokenType["runOncePath"] = 80] = "runOncePath";
    TokenType[TokenType["once"] = 81] = "once";
    TokenType[TokenType["compile"] = 82] = "compile";
    TokenType[TokenType["reboot"] = 83] = "reboot";
    TokenType[TokenType["shutdown"] = 84] = "shutdown";
    TokenType[TokenType["identifier"] = 85] = "identifier";
    TokenType[TokenType["fileIdentifier"] = 86] = "fileIdentifier";
    TokenType[TokenType["lazyGlobal"] = 87] = "lazyGlobal";
})(TokenType = exports.TokenType || (exports.TokenType = {}));
exports.isValidIdentifier = (type) => {
    switch (type) {
        case TokenType.not:
        case TokenType.and:
        case TokenType.or:
        case TokenType.set:
        case TokenType.unset:
        case TokenType.to:
        case TokenType.is:
        case TokenType.until:
        case TokenType.if:
        case TokenType.else:
        case TokenType.for:
        case TokenType.when:
        case TokenType.then:
        case TokenType.from:
        case TokenType.do:
        case TokenType.at:
        case TokenType.on:
        case TokenType.in:
        case TokenType.lock:
        case TokenType.unlock:
        case TokenType.print:
        case TokenType.local:
        case TokenType.global:
        case TokenType.parameter:
        case TokenType.function:
        case TokenType.preserve:
        case TokenType.break:
        case TokenType.return:
        case TokenType.declare:
        case TokenType.defined:
        case TokenType.toggle:
        case TokenType.wait:
        case TokenType.off:
        case TokenType.list:
        case TokenType.clearscreen:
        case TokenType.stage:
        case TokenType.add:
        case TokenType.remove:
        case TokenType.log:
        case TokenType.step:
        case TokenType.switch:
        case TokenType.copy:
        case TokenType.rename:
        case TokenType.volume:
        case TokenType.file:
        case TokenType.delete:
        case TokenType.edit:
        case TokenType.all:
        case TokenType.run:
        case TokenType.runPath:
        case TokenType.runOncePath:
        case TokenType.once:
        case TokenType.compile:
        case TokenType.reboot:
        case TokenType.shutdown:
        case TokenType.identifier:
        case TokenType.lazyGlobal:
            return true;
        default:
            return false;
    }
};
//# sourceMappingURL=tokentypes.js.map