import * as Expr from '../parser/expr';
import * as SuffixTerm from '../parser/suffixTerm';
import { IExprClass, IExprClassVisitor, ISuffixTermClass } from '../parser/types';
export declare class Generator implements IExprClassVisitor<string> {
    readonly mutation: IMutation;
    readonly logger: ILogger;
    readonly tracer: ITracer;
    constructor(mutation: IMutation, logger?: ILogger, tracer?: ITracer);
    generateExpr(exprType?: IExprClass): string;
    private genExpr;
    private draw;
    private randomEntity;
    visitExprInvalid(exprClass: IExprClass<Expr.Invalid>): string;
    visitBinary(exprClass: IExprClass<Expr.Binary>): string;
    visitUnary(exprClass: IExprClass<Expr.Unary>): string;
    visitFactor(exprClass: IExprClass<Expr.Factor>): string;
    visitSuffix(exprClass: IExprClass<Expr.Suffix>): string;
    visitAnonymousFunction(exprClass: IExprClass<Expr.Lambda>): string;
    visitSuffixTerm(exprClass: ISuffixTermClass<SuffixTerm.SuffixTerm>): string;
    visitCall(exprClass: ISuffixTermClass<SuffixTerm.Call>): string;
    visitArrayIndex(exprClass: ISuffixTermClass<SuffixTerm.ArrayIndex>): string;
    visitArrayBracket(exprClass: ISuffixTermClass<SuffixTerm.ArrayBracket>): string;
    visitDelegate(exprClass: ISuffixTermClass<SuffixTerm.Delegate>): string;
    visitLiteral(exprClass: ISuffixTermClass<SuffixTerm.Literal>): string;
    visitVariable(exprClass: ISuffixTermClass<SuffixTerm.Identifier>): string;
    visitGrouping(exprClass: ISuffixTermClass<SuffixTerm.Grouping>): string;
    private generateGrammarNode;
    private generateUnion;
    private generateOptional;
    private generateRepeat;
    private generateGrammarNodes;
    private generateInteger;
    private generateDouble;
    private generateRandomString;
    private generateIdentifier;
    private generateString;
    private generateToken;
}
