"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const generator_1 = require("./generator");
const logger_1 = require("../utilities/logger");
const expr_1 = require("../parser/expr");
const scanner_1 = require("../scanner/scanner");
const parser_1 = require("../parser/parser");
const generator = new generator_1.Generator({ active: false, rate: 0 }, logger_1.consoleLogger, logger_1.consoleTracer);
// scan source file
const scan = (source) => {
    const scanner = new scanner_1.Scanner(source);
    return scanner.scanTokens();
};
// parse source
const parseExpression = (source) => {
    const { tokens, scanErrors } = scan(source);
    const parser = new parser_1.Parser('', tokens);
    return [parser.parseExpression(), scanErrors];
};
let i = 0;
while (true) {
    for (const exprClass of expr_1.validExprTypes.slice(0, -1)) {
        if (i % 100 === 0) {
            console.log(i);
        }
        const source = generator.generateExpr(exprClass[0]);
        i += 1;
        try {
            const [{ errors }, scanErrors] = parseExpression(source);
            if (errors.length > 0 || scanErrors.length > 0) {
                console.log('Source: ', source);
                errors.map(error => console.log('Parse Error: ', error));
                scanErrors.map(error => console.log('Parse Error: ', error));
                process.exit();
            }
        }
        catch (err) {
            console.log(err);
        }
    }
}
//# sourceMappingURL=testRun.js.map