import { IRangeSequence } from './types';
import { Location, Position, Range } from 'vscode-languageserver';
export declare abstract class NodeBase implements IRangeSequence {
    /**
     * Array of all valid ranges in the syntax node
     */
    abstract readonly ranges: Range[];
    /**
     * String representation of the syntax node
     */
    toString(): string;
    /**
     * String representation of the syntax node where each element is a line
     */
    abstract toLines(): string[];
    /**
     * Position of start of syntax node
     */
    abstract readonly start: Position;
    /**
     * Position of end of syntax node
     */
    abstract readonly end: Position;
    /**
     * Create a uri location for this node element
     * @param uri uri to set location to
     */
    toLocation(uri: string): Location;
}
