import { IParseError, PartialNode } from './types';
import { Position } from 'vscode-languageserver';
import { Expr } from './expr';
import { Stmt } from './stmt';
import { Token } from '../entities/token';
export declare class ParseError implements IParseError {
    readonly inner: IParseError[];
    readonly token: Token;
    readonly failed: FailedConstructor;
    readonly message: string;
    readonly moreInfo?: string;
    readonly partial?: PartialNode;
    constructor(token: Token, failed: FailedConstructor, message: string, moreInfo?: string, partial?: PartialNode);
    readonly start: Position;
    readonly end: Position;
    readonly tag: 'parseError';
}
export declare class FailedConstructor {
    stmt: Maybe<Constructor<Stmt>>;
    expr: Maybe<Constructor<Expr>>;
    constructor(stmt: Maybe<Constructor<Stmt>>, expr: Maybe<Constructor<Expr>>);
}
export declare const failedExpr: (expr: Maybe<Constructor<Expr>>) => FailedConstructor;
export declare const failedStmt: (stmt: Constructor<Stmt> | undefined) => FailedConstructor;
export declare const failedUnknown: () => FailedConstructor;
