"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class ParseError {
    constructor(token, failed, message, moreInfo, partial) {
        this.token = token;
        this.failed = failed;
        this.message = message;
        this.moreInfo = moreInfo;
        this.partial = partial;
        this.inner = [];
    }
    get start() {
        return this.token.start;
    }
    get end() {
        return this.token.end;
    }
    get tag() {
        return 'parseError';
    }
}
exports.ParseError = ParseError;
class FailedConstructor {
    constructor(stmt, expr) {
        this.stmt = stmt;
        this.expr = expr;
    }
}
exports.FailedConstructor = FailedConstructor;
exports.failedExpr = (expr) => {
    return new FailedConstructor(undefined, expr);
};
exports.failedStmt = (stmt) => {
    return new FailedConstructor(stmt, undefined);
};
exports.failedUnknown = () => {
    return new FailedConstructor(undefined, undefined);
};
//# sourceMappingURL=parserError.js.map