import { IFindResult, TreeNode } from './types';
import * as Decl from './declare';
import * as Stmt from './stmt';
import * as Expr from './expr';
import * as SuffixTerm from './suffixTerm';
import { Position } from 'vscode-languageserver';
import { TreeExecute } from './treeExecute';
declare type Contexts = Constructor<Expr.Expr> | Constructor<Stmt.Stmt> | Constructor<SuffixTerm.SuffixTermBase> | Constructor<Decl.Parameter>;
export declare class ScriptFind extends TreeExecute<Maybe<IFindResult>> {
    private pos;
    private contexts;
    constructor();
    /**
     * Find a token within a tree node
     * @param syntaxNode node to search in
     * @param pos position to find
     * @param contexts list of contexts to captures
     */
    find(syntaxNode: TreeNode, pos: Position, ...contexts: Contexts[]): Maybe<IFindResult>;
    protected nodeAction(node: TreeNode): Maybe<IFindResult>;
    private addContext;
    private isContext;
}
export {};
