import { TreeNode } from './types';
import { Token } from '../entities/token';
import { TreeExecute } from './treeExecute';
/**
 * Check all tokens in a given tree node
 */
export declare class TokenCheck extends TreeExecute<Token[]> {
    /**
     * Construct token check
     */
    constructor();
    /**
     * Get all tokens in the syntax tree from this node down
     * @param syntaxNode syntax node to begin
     */
    orderedTokens(syntaxNode: TreeNode): Token[];
    /**
     * Add tokens from each internal node
     * @param node syntax node to begin
     */
    protected nodeAction(node: TreeNode): Token[];
}
