import { CompletionItem, MessageReader, MessageWriter } from 'vscode-languageserver';
import { Analyzer } from './analyzer';
export interface IClientConfiguration {
    completionCase: 'lowercase' | 'uppercase' | 'camelcase' | 'pascalcase';
    kerbalSpaceProgramPath?: string;
    telnetHost: string;
    telnetPort: number;
    lspPort: number;
    trace: {
        server: {
            verbosity: 'off' | 'message' | 'verbose';
            format: 'text' | 'json';
            level: 'verbose' | 'info' | 'log' | 'warn' | 'error' | 'none';
        };
    };
}
export interface IClientCapabilities {
    hasConfiguration: boolean;
    hasWorkspaceFolder: boolean;
}
export interface IServer {
    reader: MessageReader;
    writer: MessageWriter;
    workspaceFolder: string;
    workspaceUri: string;
    keywords: CompletionItem[];
    clientConfig: IClientConfiguration;
    clientCapability: IClientCapabilities;
    analyzer: Analyzer;
}
export declare const connection: import("vscode-languageserver").Connection<import("vscode-languageserver")._, import("vscode-languageserver")._, import("vscode-languageserver")._, import("vscode-languageserver")._, import("vscode-languageserver")._, import("vscode-languageserver")._>;
