"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typeCreators_1 = require("./typeCreators");
const structure_1 = require("./types/primitives/structure");
const scalar_1 = require("./types/primitives/scalar");
const delegate_1 = require("./types/primitives/delegate");
const typeGuards_1 = require("../utilities/typeGuards");
const arrayBracketCache = new Map();
exports.arrayIndexer = typeCreators_1.createArgSuffixType('list#Indexer', structure_1.structureType, scalar_1.integarType);
exports.arrayBracketIndexer = (collectionType, indexType, returnType) => {
    const typeString = `${collectionType.toTypeString()}[${indexType.toTypeString()}]`;
    const hit = arrayBracketCache.get(typeString);
    if (!typeGuards_1.empty(hit)) {
        return hit;
    }
    const type = typeCreators_1.createSuffixType(typeString, returnType);
    arrayBracketCache.set(typeString, type);
    return type;
};
exports.delegateCreation = typeCreators_1.createArgSuffixType('delegate creation', delegate_1.delegateType);
exports.suffixError = typeCreators_1.createSuffixType('Unknown suffix', structure_1.structureType);
exports.functionError = typeCreators_1.createFunctionType('Unknown function', structure_1.structureType);
exports.defaultSuffix = (name) => typeCreators_1.createSuffixType(name, structure_1.structureType);
//# sourceMappingURL=typeHelpers.js.map