import { Type } from './types/types';
import { SuffixTermBase } from '../parser/suffixTerm';
import { Position, Range } from 'vscode-languageserver';
/**
 * Storage type for suffix terms in the type checker
 */
export declare class TypeNode<T extends Type = Type> implements Range {
    readonly type: T;
    readonly node: SuffixTermBase;
    /**
     * TypeNode constructor
     * @param type type at a suffix term node
     * @param node suffix term node
     */
    constructor(type: T, node: SuffixTermBase);
    /**
     * start position of the node
     */
    readonly start: Position;
    /**
     * end position of the node
     */
    readonly end: Position;
}
