"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typeCreators_1 = require("../../typeCreators");
const typeUitlities_1 = require("../../typeUitlities");
const enumerator_1 = require("./enumerator");
const constants_1 = require("../../../utilities/constants");
const scalar_1 = require("../primitives/scalar");
const boolean_1 = require("../primitives/boolean");
const string_1 = require("../primitives/string");
const void_1 = require("../primitives/void");
const serializeableStructure_1 = require("../primitives/serializeableStructure");
exports.enumerableType = typeCreators_1.createGenericBasicType('enumerable');
typeUitlities_1.addPrototype(exports.enumerableType, serializeableStructure_1.serializableStructureType);
typeUitlities_1.addSuffixes(exports.enumerableType, typeCreators_1.createGenericArgSuffixType(constants_1.iterator, enumerator_1.enumeratorType), typeCreators_1.createGenericArgSuffixType('reverseIterator', enumerator_1.enumeratorType), typeCreators_1.createArgSuffixType('length', scalar_1.scalarType), typeCreators_1.createGenericArgSuffixType('contains', boolean_1.booleanType, typeCreators_1.tType), typeCreators_1.createArgSuffixType('empty', boolean_1.booleanType), typeCreators_1.createArgSuffixType('dump', string_1.stringType));
exports.collectionType = typeCreators_1.createGenericBasicType('collection');
typeUitlities_1.addPrototype(exports.collectionType, exports.enumerableType);
typeUitlities_1.addSuffixes(exports.collectionType, typeCreators_1.createArgSuffixType('clear', void_1.voidType));
//# sourceMappingURL=enumerable.js.map