"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typeCreators_1 = require("../../typeCreators");
const typeUitlities_1 = require("../../typeUitlities");
const structure_1 = require("../primitives/structure");
const void_1 = require("../primitives/void");
const userList_1 = require("./userList");
const boolean_1 = require("../primitives/boolean");
const scalar_1 = require("../primitives/scalar");
const serializeableStructure_1 = require("../primitives/serializeableStructure");
exports.lexiconType = typeCreators_1.createStructureType('lexicon');
typeUitlities_1.addPrototype(exports.lexiconType, serializeableStructure_1.serializableStructureType);
typeUitlities_1.addSuffixes(exports.lexiconType, typeCreators_1.createArgSuffixType('clear', void_1.voidType), typeCreators_1.createSuffixType('keys', userList_1.userListType), typeCreators_1.createArgSuffixType('haskey', boolean_1.booleanType, structure_1.structureType), typeCreators_1.createArgSuffixType('hasvalue', boolean_1.booleanType, structure_1.structureType), typeCreators_1.createSuffixType('values', userList_1.userListType), typeCreators_1.createArgSuffixType('copy', exports.lexiconType), typeCreators_1.createArgSuffixType('length', scalar_1.scalarType), typeCreators_1.createArgSuffixType('remove', structure_1.structureType, boolean_1.booleanType), typeCreators_1.createArgSuffixType('add', void_1.voidType, structure_1.structureType, structure_1.structureType), typeCreators_1.createSetSuffixType('casesensitive', boolean_1.booleanType), typeCreators_1.createSetSuffixType('case', boolean_1.booleanType));
//# sourceMappingURL=lexicon.js.map