"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ksType_1 = require("../ksType");
const typeCreators_1 = require("../typeCreators");
const typeUitlities_1 = require("../typeUitlities");
const structure_1 = require("./primitives/structure");
const scalar_1 = require("./primitives/scalar");
exports.gType = new ksType_1.ConstantType('g', 6.67384e-11);
typeUitlities_1.addPrototype(exports.gType, scalar_1.doubleType);
exports.eType = new ksType_1.ConstantType('e', Math.E);
typeUitlities_1.addPrototype(exports.eType, scalar_1.doubleType);
exports.piType = new ksType_1.ConstantType('pi', Math.PI);
typeUitlities_1.addPrototype(exports.piType, scalar_1.doubleType);
exports.cType = new ksType_1.ConstantType('c', 299792458.0);
typeUitlities_1.addPrototype(exports.cType, scalar_1.doubleType);
exports.atmToKpaType = new ksType_1.ConstantType('atmtokpa', 101.325);
typeUitlities_1.addPrototype(exports.atmToKpaType, scalar_1.doubleType);
exports.kpaToAtmType = new ksType_1.ConstantType('kpatoatm', 0.00986923266716012830002467308167);
typeUitlities_1.addPrototype(exports.kpaToAtmType, scalar_1.doubleType);
exports.degToRadType = new ksType_1.ConstantType('degtorad', 0.01745329251994329576923690768489);
typeUitlities_1.addPrototype(exports.degToRadType, scalar_1.doubleType);
exports.radToDegType = new ksType_1.ConstantType('radtodeg', 57.295779513082320876798154814105);
typeUitlities_1.addPrototype(exports.radToDegType, scalar_1.doubleType);
exports.constantType = typeCreators_1.createStructureType('constant');
typeUitlities_1.addPrototype(exports.constantType, structure_1.structureType);
typeUitlities_1.addSuffixes(exports.constantType, typeCreators_1.createSuffixType(exports.gType.name, exports.gType), typeCreators_1.createSuffixType(exports.eType.name, exports.eType), typeCreators_1.createSuffixType(exports.piType.name, exports.piType), typeCreators_1.createSuffixType(exports.cType.name, exports.cType), typeCreators_1.createSuffixType(exports.atmToKpaType.name, exports.atmToKpaType), typeCreators_1.createSuffixType(exports.kpaToAtmType.name, exports.kpaToAtmType), typeCreators_1.createSuffixType(exports.degToRadType.name, exports.degToRadType), typeCreators_1.createSuffixType(exports.radToDegType.name, exports.radToDegType));
//# sourceMappingURL=constant.js.map