"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typeCreators_1 = require("../typeCreators");
const typeUitlities_1 = require("../typeUitlities");
const structure_1 = require("./primitives/structure");
const vector_1 = require("./collections/vector");
const scalar_1 = require("./primitives/scalar");
const boolean_1 = require("./primitives/boolean");
exports.flightControlType = typeCreators_1.createStructureType('flightControl');
typeUitlities_1.addPrototype(exports.flightControlType, structure_1.structureType);
typeUitlities_1.addSuffixes(exports.flightControlType, typeCreators_1.createSetSuffixType('yaw', scalar_1.scalarType), typeCreators_1.createSetSuffixType('yawTrim', scalar_1.scalarType), typeCreators_1.createSetSuffixType('roll', scalar_1.scalarType), typeCreators_1.createSetSuffixType('rollTrim', scalar_1.scalarType), typeCreators_1.createSetSuffixType('pitch', scalar_1.scalarType), typeCreators_1.createSetSuffixType('pitchTrim', scalar_1.scalarType), typeCreators_1.createSetSuffixType('rotation', vector_1.vectorType), typeCreators_1.createSetSuffixType('fore', scalar_1.scalarType), typeCreators_1.createSetSuffixType('starboard', scalar_1.scalarType), typeCreators_1.createSetSuffixType('top', scalar_1.scalarType), typeCreators_1.createSetSuffixType('translation', vector_1.vectorType), typeCreators_1.createSetSuffixType('wheelSteer', scalar_1.scalarType), typeCreators_1.createSetSuffixType('wheelSteerTrim', scalar_1.scalarType), typeCreators_1.createSetSuffixType('mainThrottle', scalar_1.scalarType), typeCreators_1.createSetSuffixType('wheelThrottle', scalar_1.scalarType), typeCreators_1.createSetSuffixType('wheelThrottleTrim', scalar_1.scalarType), typeCreators_1.createSetSuffixType('bound', boolean_1.booleanType), typeCreators_1.createSuffixType('neutral', boolean_1.booleanType), typeCreators_1.createSuffixType('pilotyaw', scalar_1.scalarType), typeCreators_1.createSuffixType('pilotYawTrim', scalar_1.scalarType), typeCreators_1.createSuffixType('pilotRoll', scalar_1.scalarType), typeCreators_1.createSuffixType('pliotRollTrim', scalar_1.scalarType), typeCreators_1.createSuffixType('pilotPitch', scalar_1.scalarType), typeCreators_1.createSuffixType('pilotPitchTrim', scalar_1.scalarType), typeCreators_1.createSuffixType('pilotFore', scalar_1.scalarType), typeCreators_1.createSuffixType('pilotStarboard', scalar_1.scalarType), typeCreators_1.createSuffixType('pilotTop', scalar_1.scalarType), typeCreators_1.createSuffixType('pilotWheelThrottle', scalar_1.scalarType), typeCreators_1.createSuffixType('pilotWheelThrottleTrim', scalar_1.scalarType), typeCreators_1.createSuffixType('pilotWheelSteer', scalar_1.scalarType), typeCreators_1.createSuffixType('pilotWheelSteerTrim', scalar_1.scalarType), typeCreators_1.createSuffixType('pilotNeutral', boolean_1.booleanType), typeCreators_1.createSuffixType('pilotRotation', vector_1.vectorType), typeCreators_1.createSuffixType('pilotTranslation', vector_1.vectorType), typeCreators_1.createSetSuffixType('pilotMainThrottle', scalar_1.scalarType));
//# sourceMappingURL=flightControl.js.map