"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typeCreators_1 = require("../typeCreators");
const typeUitlities_1 = require("../typeUitlities");
const vector_1 = require("./collections/vector");
const orbitalVelocity_1 = require("./orbitalVelocity");
const scalar_1 = require("./primitives/scalar");
const serializeableStructure_1 = require("./primitives/serializeableStructure");
const bodyTarget_1 = require("./orbital/bodyTarget");
exports.geoCoordinatesType = typeCreators_1.createStructureType('geoCoordinates');
typeUitlities_1.addPrototype(exports.geoCoordinatesType, serializeableStructure_1.serializableStructureType);
typeUitlities_1.addSuffixes(exports.geoCoordinatesType, typeCreators_1.createSuffixType('lat', scalar_1.scalarType), typeCreators_1.createSuffixType('lng', scalar_1.scalarType), typeCreators_1.createSuffixType('body', bodyTarget_1.bodyTargetType), typeCreators_1.createSuffixType('terrainHeight', scalar_1.scalarType), typeCreators_1.createSuffixType('distance', scalar_1.scalarType), typeCreators_1.createSuffixType('heading', scalar_1.scalarType), typeCreators_1.createSuffixType('bearing', scalar_1.scalarType), typeCreators_1.createSuffixType('position', vector_1.vectorType), typeCreators_1.createSuffixType('velocity', orbitalVelocity_1.orbitableVelocityType), typeCreators_1.createArgSuffixType('altitudePosition', vector_1.vectorType, scalar_1.scalarType), typeCreators_1.createArgSuffixType('altitudeVelocity', orbitalVelocity_1.orbitableVelocityType, scalar_1.scalarType));
//# sourceMappingURL=geoCoordinates.js.map