"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typeCreators_1 = require("../../typeCreators");
const typeUitlities_1 = require("../../typeUitlities");
const widget_1 = require("./widget");
const userDelegate_1 = require("../userDelegate");
const scrollBox_1 = require("./scrollBox");
const spacing_1 = require("./spacing");
const label_1 = require("./elements/label");
const textField_1 = require("./elements/textField");
const button_1 = require("./elements/button");
const popupMenu_1 = require("./elements/popupMenu");
const slider_1 = require("./elements/slider");
const void_1 = require("../primitives/void");
const userList_1 = require("../collections/userList");
const string_1 = require("../primitives/string");
const boolean_1 = require("../primitives/boolean");
const scalar_1 = require("../primitives/scalar");
exports.boxType = typeCreators_1.createStructureType('box');
typeUitlities_1.addPrototype(exports.boxType, widget_1.widgetType);
typeUitlities_1.addSuffixes(exports.boxType, typeCreators_1.createArgSuffixType('addLabel', label_1.labelType, string_1.stringType), typeCreators_1.createArgSuffixType('addTextField', textField_1.textFieldType, string_1.stringType), typeCreators_1.createArgSuffixType('addButton', button_1.buttonType, string_1.stringType), typeCreators_1.createArgSuffixType('addRadioButton', button_1.buttonType, string_1.stringType, boolean_1.booleanType), typeCreators_1.createArgSuffixType('addCheckBox', button_1.buttonType, string_1.stringType, boolean_1.booleanType), typeCreators_1.createArgSuffixType('addPopUpMenu', popupMenu_1.popupMenuType, string_1.stringType), typeCreators_1.createArgSuffixType('addHSlider', slider_1.sliderType, string_1.stringType, scalar_1.doubleType, scalar_1.doubleType, scalar_1.doubleType), typeCreators_1.createArgSuffixType('addVSlider', slider_1.sliderType, string_1.stringType, scalar_1.doubleType, scalar_1.doubleType, scalar_1.doubleType), typeCreators_1.createSuffixType('addHBox', exports.boxType), typeCreators_1.createSuffixType('addVBox', exports.boxType), typeCreators_1.createSuffixType('addHLayout', exports.boxType), typeCreators_1.createSuffixType('addVLayout', exports.boxType), typeCreators_1.createSuffixType('addScrollBox', scrollBox_1.scrollBoxType), typeCreators_1.createSuffixType('addStack', scrollBox_1.scrollBoxType), typeCreators_1.createArgSuffixType('addSpacing', spacing_1.spacingType, scalar_1.integarType), typeCreators_1.createSuffixType('widgets', userList_1.userListType), typeCreators_1.createSuffixType('radioValue', string_1.stringType), typeCreators_1.createSetSuffixType('onRadioChange', userDelegate_1.userDelegateType), typeCreators_1.createArgSuffixType('showOnly', void_1.voidType, widget_1.widgetType), typeCreators_1.createArgSuffixType('clear', void_1.voidType));
//# sourceMappingURL=box.js.map