"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typeCreators_1 = require("../../typeCreators");
const typeUitlities_1 = require("../../typeUitlities");
const structure_1 = require("../primitives/structure");
const volume_1 = require("./volume");
const userList_1 = require("../collections/userList");
const scalar_1 = require("../primitives/scalar");
const string_1 = require("../primitives/string");
const boolean_1 = require("../primitives/boolean");
const serializeableStructure_1 = require("../primitives/serializeableStructure");
exports.pathType = typeCreators_1.createStructureType('path');
typeUitlities_1.addPrototype(exports.pathType, serializeableStructure_1.serializableStructureType);
typeUitlities_1.addSuffixes(exports.pathType, typeCreators_1.createSuffixType('volume', volume_1.volumeType), typeCreators_1.createSuffixType('segments', userList_1.userListType), typeCreators_1.createSuffixType('length', scalar_1.integarType), typeCreators_1.createSuffixType('name', string_1.stringType), typeCreators_1.createSuffixType('hasExtension', boolean_1.booleanType), typeCreators_1.createSuffixType('extension', string_1.stringType), typeCreators_1.createSuffixType('root', exports.pathType), typeCreators_1.createSuffixType('parent', exports.pathType), typeCreators_1.createArgSuffixType('isParent', exports.pathType, boolean_1.booleanType), typeCreators_1.createArgSuffixType('changeName', exports.pathType, string_1.stringType), typeCreators_1.createArgSuffixType('changeExtension', exports.pathType, string_1.stringType), typeCreators_1.createVarSuffixType('combine', exports.pathType, typeCreators_1.createVarType(structure_1.structureType)));
//# sourceMappingURL=path.js.map