"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typeUitlities_1 = require("../../typeUitlities");
const orbitable_1 = require("./orbitable");
const serializeableStructure_1 = require("../primitives/serializeableStructure");
const typeCreators_1 = require("../../typeCreators");
const string_1 = require("../primitives/string");
const scalar_1 = require("../primitives/scalar");
const boolean_1 = require("../primitives/boolean");
const direction_1 = require("../direction");
const orbitInfo_1 = require("../orbitInfo");
const vector_1 = require("../collections/vector");
const orbitalVelocity_1 = require("../orbitalVelocity");
const geoCoordinates_1 = require("../geoCoordinates");
const userList_1 = require("../collections/userList");
const bodyatmosphere_1 = require("../bodyatmosphere");
const list_1 = require("../collections/list");
const part_1 = require("../parts/part");
const dockingPort_1 = require("../parts/dockingPort");
const decoupler_1 = require("../parts/decoupler");
const flightControl_1 = require("../flightControl");
const aggregateResource_1 = require("../aggregateResource");
const loadDistance_1 = require("../loadDistance");
const vesselConnection_1 = require("../communication/vesselConnection");
const messageQueue_1 = require("../communication/messageQueue");
const void_1 = require("../primitives/void");
const uniqueset_1 = require("../collections/uniqueset");
const userDelegate_1 = require("../userDelegate");
const bodyTarget_1 = require("./bodyTarget");
const vesselTarget_1 = require("./vesselTarget");
const partModule_1 = require("../parts/partModule");
const crew_1 = require("../crew");
const vesselSensors_1 = require("../vessel/vesselSensors");
let set = false;
exports.oribitalInitializer = () => {
    if (set) {
        return;
    }
    set = true;
    typeUitlities_1.addPrototype(orbitable_1.orbitableType, serializeableStructure_1.serializableStructureType);
    typeUitlities_1.addSuffixes(orbitable_1.orbitableType, typeCreators_1.createSuffixType('name', string_1.stringType), typeCreators_1.createSuffixType('apoapsis', scalar_1.scalarType), typeCreators_1.createSuffixType('periapsis', scalar_1.scalarType), typeCreators_1.createSuffixType('body', bodyTarget_1.bodyTargetType), typeCreators_1.createArgSuffixType('hasBody', boolean_1.booleanType), typeCreators_1.createArgSuffixType('hasObt', boolean_1.booleanType), typeCreators_1.createArgSuffixType('hasOrbit', boolean_1.booleanType), typeCreators_1.createSuffixType('up', direction_1.directionType), typeCreators_1.createSuffixType('north', direction_1.directionType), typeCreators_1.createSuffixType('prograde', direction_1.directionType), typeCreators_1.createSuffixType('retrograde', direction_1.directionType), typeCreators_1.createSuffixType('srfPrograde', direction_1.directionType), typeCreators_1.createSuffixType('srfRetrograde', direction_1.directionType), typeCreators_1.createSuffixType('obt', orbitInfo_1.orbitInfoType), typeCreators_1.createSuffixType('orbit', orbitInfo_1.orbitInfoType), typeCreators_1.createSuffixType('position', vector_1.vectorType), typeCreators_1.createSuffixType('velocity', orbitalVelocity_1.orbitableVelocityType), typeCreators_1.createSuffixType('distance', scalar_1.scalarType), typeCreators_1.createSuffixType('direction', direction_1.directionType), typeCreators_1.createSuffixType('latitude', scalar_1.scalarType), typeCreators_1.createSuffixType('longitude', scalar_1.scalarType), typeCreators_1.createSuffixType('altitude', scalar_1.scalarType), typeCreators_1.createSuffixType('geoPosition', geoCoordinates_1.geoCoordinatesType), typeCreators_1.createSuffixType('patches', userList_1.userListType));
    typeUitlities_1.addPrototype(bodyTarget_1.bodyTargetType, orbitable_1.orbitableType);
    typeUitlities_1.addSuffixes(bodyTarget_1.bodyTargetType, typeCreators_1.createSuffixType('name', string_1.stringType), typeCreators_1.createSuffixType('description', string_1.stringType), typeCreators_1.createSuffixType('mass', scalar_1.scalarType), typeCreators_1.createSuffixType('hasOcean', boolean_1.booleanType), typeCreators_1.createSuffixType('hasSolidSurface', boolean_1.booleanType), typeCreators_1.createSuffixType('orbitingChildren', userList_1.userListType), typeCreators_1.createSuffixType('altitude', scalar_1.scalarType), typeCreators_1.createSuffixType('radius', scalar_1.scalarType), typeCreators_1.createSuffixType('mu', scalar_1.scalarType), typeCreators_1.createSuffixType('rotationPeriod', scalar_1.scalarType), typeCreators_1.createSuffixType('atm', bodyatmosphere_1.bodyAtmosphereType), typeCreators_1.createSuffixType('angularVel', vector_1.vectorType), typeCreators_1.createSuffixType('soiRadius', scalar_1.scalarType), typeCreators_1.createSuffixType('rotationAngle', scalar_1.scalarType), typeCreators_1.createArgSuffixType('geoPositionOf', geoCoordinates_1.geoCoordinatesType, vector_1.vectorType), typeCreators_1.createArgSuffixType('altitudeOf', scalar_1.scalarType, vector_1.vectorType), typeCreators_1.createArgSuffixType('geoPositionLatLng', geoCoordinates_1.geoCoordinatesType, scalar_1.scalarType, scalar_1.scalarType));
    typeUitlities_1.addPrototype(vesselTarget_1.vesselTargetType, orbitable_1.orbitableType);
    typeUitlities_1.addSuffixes(vesselTarget_1.vesselTargetType, typeCreators_1.createArgSuffixType('partsNamed', list_1.listType.toConcreteType(part_1.partType), string_1.stringType), typeCreators_1.createArgSuffixType('partsNamedPattern', list_1.listType.toConcreteType(part_1.partType), string_1.stringType), typeCreators_1.createArgSuffixType('partsTitled', list_1.listType.toConcreteType(part_1.partType), string_1.stringType), typeCreators_1.createArgSuffixType('partsTitledPattern', list_1.listType.toConcreteType(part_1.partType), string_1.stringType), typeCreators_1.createArgSuffixType('partsDubbed', list_1.listType.toConcreteType(part_1.partType), string_1.stringType), typeCreators_1.createArgSuffixType('partsDubbedPattern', list_1.listType.toConcreteType(part_1.partType), string_1.stringType), typeCreators_1.createArgSuffixType('modulesNamed', list_1.listType.toConcreteType(partModule_1.partModuleType), string_1.stringType), typeCreators_1.createArgSuffixType('partsInGroup', list_1.listType.toConcreteType(part_1.partType), string_1.stringType), typeCreators_1.createArgSuffixType('modulesInGroup', list_1.listType.toConcreteType(partModule_1.partModuleType), string_1.stringType), typeCreators_1.createArgSuffixType('partStagged', list_1.listType.toConcreteType(part_1.partType), string_1.stringType), typeCreators_1.createArgSuffixType('partStaggedPattern', list_1.listType.toConcreteType(part_1.partType), string_1.stringType), typeCreators_1.createArgSuffixType('allTaggedParts', userList_1.userListType), typeCreators_1.createArgSuffixType('parts', list_1.listType.toConcreteType(part_1.partType)), typeCreators_1.createArgSuffixType('dockingPorts', list_1.listType.toConcreteType(dockingPort_1.dockingPortType)), typeCreators_1.createArgSuffixType('decouplers', list_1.listType.toConcreteType(decoupler_1.decouplerType)), typeCreators_1.createArgSuffixType('separators', list_1.listType.toConcreteType(decoupler_1.decouplerType)), typeCreators_1.createArgSuffixType('elements', userList_1.userListType), typeCreators_1.createSuffixType('control', flightControl_1.flightControlType), typeCreators_1.createSuffixType('bearing', scalar_1.scalarType), typeCreators_1.createSuffixType('heading', scalar_1.scalarType), typeCreators_1.createSuffixType('availableThrust', scalar_1.scalarType), typeCreators_1.createArgSuffixType('availableThrustAt', scalar_1.scalarType, scalar_1.scalarType), typeCreators_1.createSuffixType('maxThrust', scalar_1.scalarType), typeCreators_1.createArgSuffixType('maxThrustAt', scalar_1.scalarType, scalar_1.scalarType), typeCreators_1.createSuffixType('facing', direction_1.directionType), typeCreators_1.createSuffixType('angularMomentum', vector_1.vectorType), typeCreators_1.createSuffixType('angularVel', vector_1.vectorType), typeCreators_1.createSuffixType('mass', scalar_1.scalarType), typeCreators_1.createSuffixType('verticalSpeed', scalar_1.scalarType), typeCreators_1.createSuffixType('groundSpeed', scalar_1.scalarType), typeCreators_1.createSuffixType('airSpeed', scalar_1.scalarType), typeCreators_1.createSuffixType('shipName', string_1.stringType), typeCreators_1.createSuffixType('name', string_1.stringType), typeCreators_1.createSuffixType('type', string_1.stringType), typeCreators_1.createSuffixType('sensors', vesselSensors_1.vesselSensorsType), typeCreators_1.createSuffixType('termVelocity', scalar_1.scalarType), typeCreators_1.createSuffixType('dynamicPressure', scalar_1.scalarType), typeCreators_1.createSuffixType('q', scalar_1.scalarType), typeCreators_1.createSuffixType('loaded', boolean_1.booleanType), typeCreators_1.createSuffixType('unpacked', boolean_1.booleanType), typeCreators_1.createSuffixType('rootPart', part_1.partType), typeCreators_1.createSuffixType('controlPart', part_1.partType), typeCreators_1.createSuffixType('dryMass', scalar_1.scalarType), typeCreators_1.createSuffixType('wetMass', scalar_1.scalarType), typeCreators_1.createSuffixType('resources', list_1.listType.toConcreteType(aggregateResource_1.aggregateResourceType)), typeCreators_1.createSuffixType('loadDistance', loadDistance_1.loadDistanceType), typeCreators_1.createArgSuffixType('isDead', boolean_1.booleanType), typeCreators_1.createSuffixType('status', string_1.stringType), typeCreators_1.createSuffixType('latitude', scalar_1.scalarType), typeCreators_1.createSuffixType('longitude', scalar_1.scalarType), typeCreators_1.createSuffixType('altitude', scalar_1.scalarType), typeCreators_1.createSuffixType('crew', list_1.listType.toConcreteType(crew_1.crewType)), typeCreators_1.createSuffixType('crewCapacity', scalar_1.scalarType), typeCreators_1.createSuffixType('connection', vesselConnection_1.vesselConnectionType), typeCreators_1.createSuffixType('messages', messageQueue_1.messageQueueType), typeCreators_1.createArgSuffixType('startTracking', void_1.voidType), typeCreators_1.createArgSuffixType('soiChangeWatchers', uniqueset_1.uniqueSetType.toConcreteType(userDelegate_1.userDelegateType)));
};
//# sourceMappingURL=initialize.js.map