"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typeCreators_1 = require("../../typeCreators");
const typeUitlities_1 = require("../../typeUitlities");
const structure_1 = require("../primitives/structure");
const direction_1 = require("../direction");
const vector_1 = require("../collections/vector");
const list_1 = require("../collections/list");
const void_1 = require("../primitives/void");
const userList_1 = require("../collections/userList");
const string_1 = require("../primitives/string");
const scalar_1 = require("../primitives/scalar");
const boolean_1 = require("../primitives/boolean");
const partModule_1 = require("./partModule");
const vesselTarget_1 = require("../orbital/vesselTarget");
exports.partType = typeCreators_1.createStructureType('part');
typeUitlities_1.addPrototype(exports.partType, structure_1.structureType);
typeUitlities_1.addSuffixes(exports.partType, typeCreators_1.createArgSuffixType('controlFrom', void_1.voidType), typeCreators_1.createSuffixType('name', string_1.stringType), typeCreators_1.createSuffixType('fuelCrossFeed', boolean_1.booleanType), typeCreators_1.createSuffixType('title', string_1.stringType), typeCreators_1.createSuffixType('stage', scalar_1.scalarType), typeCreators_1.createSuffixType('uid', string_1.stringType), typeCreators_1.createSuffixType('rotation', direction_1.directionType), typeCreators_1.createSuffixType('position', vector_1.vectorType), typeCreators_1.createSetSuffixType('tag', string_1.stringType), typeCreators_1.createSuffixType('facing', direction_1.directionType), typeCreators_1.createSuffixType('resources', userList_1.userListType), typeCreators_1.createSuffixType('targetable', boolean_1.booleanType), typeCreators_1.createSuffixType('ship', vesselTarget_1.vesselTargetType), typeCreators_1.createArgSuffixType('hasModule', boolean_1.booleanType, string_1.stringType), typeCreators_1.createArgSuffixType('getModule', partModule_1.partModuleType, string_1.stringType), typeCreators_1.createArgSuffixType('getModulesByIndex', partModule_1.partModuleType, scalar_1.scalarType), typeCreators_1.createSuffixType('modules', userList_1.userListType), typeCreators_1.createSuffixType('allModules', userList_1.userListType), typeCreators_1.createSuffixType('parent', structure_1.structureType), typeCreators_1.createSuffixType('decoupler', structure_1.structureType), typeCreators_1.createSuffixType('separator', structure_1.structureType), typeCreators_1.createSuffixType('decoupledIn', scalar_1.scalarType), typeCreators_1.createSuffixType('separatedIn', scalar_1.scalarType), typeCreators_1.createSuffixType('hasParent', boolean_1.booleanType), typeCreators_1.createSuffixType('children', list_1.listType.toConcreteType(exports.partType)), typeCreators_1.createSuffixType('dryMass', scalar_1.scalarType), typeCreators_1.createSuffixType('mass', scalar_1.scalarType), typeCreators_1.createSuffixType('wetMass', scalar_1.scalarType), typeCreators_1.createSuffixType('hasPhysics', boolean_1.booleanType));
//# sourceMappingURL=part.js.map