"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typeUitlities_1 = require("../../typeUitlities");
const structure_1 = require("./structure");
const typeCreators_1 = require("../../typeCreators");
const string_1 = require("./string");
const boolean_1 = require("./boolean");
const void_1 = require("./void");
const serializeableStructure_1 = require("./serializeableStructure");
const primitives_1 = require("./primitives");
const scalar_1 = require("./scalar");
const list_1 = require("../collections/list");
const delegate_1 = require("./delegate");
let set = false;
exports.primitiveInitializer = () => {
    if (set) {
        return;
    }
    set = true;
    // ------------------ structure ---------------------------
    typeUitlities_1.addSuffixes(structure_1.structureType, typeCreators_1.createArgSuffixType('tostring', string_1.stringType), typeCreators_1.createArgSuffixType('hassuffix', boolean_1.booleanType, string_1.stringType), typeCreators_1.createArgSuffixType('suffixnames', void_1.voidType), typeCreators_1.createArgSuffixType('isserializable', boolean_1.booleanType), typeCreators_1.createArgSuffixType('typename', string_1.stringType), typeCreators_1.createArgSuffixType('istype', boolean_1.booleanType, string_1.stringType), typeCreators_1.createArgSuffixType('inheritance', string_1.stringType));
    // ------------------ serializable structure ---------------------------
    typeUitlities_1.addPrototype(serializeableStructure_1.serializableStructureType, structure_1.structureType);
    // ------------------ primitives ---------------------------
    typeUitlities_1.addPrototype(primitives_1.primitiveType, structure_1.structureType);
    // ------------------ string ---------------------------
    typeUitlities_1.addOperators(string_1.stringType, [0 /* plus */, string_1.stringType], [5 /* greaterThan */, boolean_1.booleanType], [6 /* lessThan */, boolean_1.booleanType], [7 /* greaterThanEqual */, boolean_1.booleanType], [8 /* lessThanEqual */, boolean_1.booleanType], [10 /* equal */, boolean_1.booleanType], [9 /* notEqual */, boolean_1.booleanType]);
    typeUitlities_1.addPrototype(string_1.stringType, primitives_1.primitiveType);
    typeUitlities_1.addSuffixes(string_1.stringType, typeCreators_1.createArgSuffixType('length', scalar_1.scalarType), typeCreators_1.createArgSuffixType('substring', string_1.stringType, scalar_1.scalarType, scalar_1.scalarType), typeCreators_1.createArgSuffixType('contains', boolean_1.booleanType, string_1.stringType), typeCreators_1.createArgSuffixType('endswith', boolean_1.booleanType, string_1.stringType), typeCreators_1.createArgSuffixType('findat', scalar_1.scalarType, string_1.stringType, scalar_1.scalarType), typeCreators_1.createArgSuffixType('insert', string_1.stringType, scalar_1.scalarType, string_1.stringType), typeCreators_1.createArgSuffixType('findlastat', scalar_1.scalarType, string_1.stringType, scalar_1.scalarType), typeCreators_1.createArgSuffixType('padleft', string_1.stringType, scalar_1.scalarType), typeCreators_1.createArgSuffixType('padright', string_1.stringType, scalar_1.scalarType), typeCreators_1.createArgSuffixType('remove', string_1.stringType, scalar_1.scalarType, scalar_1.scalarType), typeCreators_1.createArgSuffixType('replace', string_1.stringType, string_1.stringType, string_1.stringType), typeCreators_1.createArgSuffixType('split', list_1.listType.toConcreteType(string_1.stringType), string_1.stringType), typeCreators_1.createArgSuffixType('startswith', boolean_1.booleanType, string_1.stringType), typeCreators_1.createArgSuffixType('tolower', string_1.stringType), typeCreators_1.createArgSuffixType('toupper', string_1.stringType), typeCreators_1.createArgSuffixType('trim', string_1.stringType), typeCreators_1.createArgSuffixType('trimend', string_1.stringType), typeCreators_1.createArgSuffixType('trimstart', string_1.stringType), typeCreators_1.createArgSuffixType('matchespattern', boolean_1.booleanType, string_1.stringType), typeCreators_1.createArgSuffixType('tonumber', scalar_1.scalarType, structure_1.structureType), typeCreators_1.createArgSuffixType('toscalar', scalar_1.scalarType, structure_1.structureType), typeCreators_1.createArgSuffixType('format', string_1.stringType, structure_1.structureType));
    // ------------------ scalar ---------------------------
    typeUitlities_1.addOperators(scalar_1.scalarType, [0 /* plus */, scalar_1.scalarType], [1 /* subtract */, scalar_1.scalarType], [2 /* multiply */, scalar_1.scalarType], [3 /* divide */, scalar_1.scalarType], [4 /* power */, scalar_1.scalarType], [5 /* greaterThan */, boolean_1.booleanType], [6 /* lessThan */, boolean_1.booleanType], [7 /* greaterThanEqual */, boolean_1.booleanType], [8 /* lessThanEqual */, boolean_1.booleanType], [9 /* notEqual */, boolean_1.booleanType], [10 /* equal */, boolean_1.booleanType]);
    typeUitlities_1.addPrototype(scalar_1.scalarType, primitives_1.primitiveType);
    // ------------------ integar ---------------------------
    typeUitlities_1.addPrototype(scalar_1.integarType, scalar_1.scalarType);
    // ------------------ double ---------------------------
    typeUitlities_1.addPrototype(scalar_1.doubleType, scalar_1.scalarType);
    // ------------------ delegate ---------------------------
    typeUitlities_1.addPrototype(delegate_1.delegateType, structure_1.structureType);
    typeUitlities_1.addSuffixes(delegate_1.delegateType, typeCreators_1.createVarSuffixType('call', structure_1.structureType, typeCreators_1.createVarType(structure_1.structureType)), typeCreators_1.createVarSuffixType('bind', delegate_1.delegateType, typeCreators_1.createVarType(structure_1.structureType)), typeCreators_1.createArgSuffixType('isdead', boolean_1.booleanType));
    // ------------------ boolean ---------------------------
    typeUitlities_1.addOperators(boolean_1.booleanType, [9 /* notEqual */, boolean_1.booleanType], [10 /* equal */, boolean_1.booleanType]);
    typeUitlities_1.addPrototype(boolean_1.booleanType, primitives_1.primitiveType);
};
//# sourceMappingURL=initialize.js.map