"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typeCreators_1 = require("../typeCreators");
const typeUitlities_1 = require("../typeUitlities");
const structure_1 = require("./primitives/structure");
const pidLoop_1 = require("./pidLoop");
const direction_1 = require("./direction");
const void_1 = require("./primitives/void");
const boolean_1 = require("./primitives/boolean");
const scalar_1 = require("./primitives/scalar");
exports.steeringManagerType = typeCreators_1.createStructureType('steeringManager');
typeUitlities_1.addPrototype(exports.steeringManagerType, structure_1.structureType);
typeUitlities_1.addSuffixes(exports.steeringManagerType, typeCreators_1.createSuffixType('pitchPid', pidLoop_1.pidLoopType), typeCreators_1.createSuffixType('yawPid', pidLoop_1.pidLoopType), typeCreators_1.createSuffixType('rollPid', pidLoop_1.pidLoopType), typeCreators_1.createSuffixType('enabled', boolean_1.booleanType), typeCreators_1.createSuffixType('target', direction_1.directionType), typeCreators_1.createArgSuffixType('resetPids', void_1.voidType), typeCreators_1.createArgSuffixType('resetToDefault', void_1.voidType), typeCreators_1.createSetSuffixType('showFacingVectors', boolean_1.booleanType), typeCreators_1.createSetSuffixType('showAngularVectors', boolean_1.booleanType), typeCreators_1.createSetSuffixType('showSteeringStats', boolean_1.booleanType), typeCreators_1.createSetSuffixType('writeCsvFiles', boolean_1.booleanType), typeCreators_1.createSetSuffixType('pitchTs', scalar_1.scalarType), typeCreators_1.createSetSuffixType('yawTs', scalar_1.scalarType), typeCreators_1.createSetSuffixType('rollTs', scalar_1.scalarType), typeCreators_1.createSetSuffixType('maxStoppingTime', scalar_1.scalarType), typeCreators_1.createSuffixType('angleError', scalar_1.scalarType), typeCreators_1.createSuffixType('pitchError', scalar_1.scalarType), typeCreators_1.createSuffixType('yawError', scalar_1.scalarType), typeCreators_1.createSuffixType('rollError', scalar_1.scalarType), typeCreators_1.createSetSuffixType('pitchTorqueAdjust', scalar_1.scalarType), typeCreators_1.createSetSuffixType('yawTorqueAdjust', scalar_1.scalarType), typeCreators_1.createSetSuffixType('rollTorqueAdjust', scalar_1.scalarType), typeCreators_1.createSetSuffixType('pitchTorqueFactor', scalar_1.scalarType), typeCreators_1.createSetSuffixType('yawTorqueFactor', scalar_1.scalarType), typeCreators_1.createSetSuffixType('rollTorqueFactor', scalar_1.scalarType), typeCreators_1.createSuffixType('averageDurction', scalar_1.scalarType), typeCreators_1.createSetSuffixType('rollControlAngleRange', scalar_1.scalarType));
//# sourceMappingURL=steeringManager.js.map