"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typeCreators_1 = require("../typeCreators");
const typeUitlities_1 = require("../typeUitlities");
const structure_1 = require("./primitives/structure");
const vector_1 = require("./collections/vector");
const string_1 = require("./primitives/string");
const scalar_1 = require("./primitives/scalar");
const boolean_1 = require("./primitives/boolean");
const geoCoordinates_1 = require("./geoCoordinates");
const bodyTarget_1 = require("./orbital/bodyTarget");
exports.waypointType = typeCreators_1.createStructureType('waypoint');
typeUitlities_1.addPrototype(exports.waypointType, structure_1.structureType);
typeUitlities_1.addSuffixes(exports.waypointType, typeCreators_1.createArgSuffixType('dump', string_1.stringType), typeCreators_1.createArgSuffixType('name', string_1.stringType), typeCreators_1.createArgSuffixType('body', bodyTarget_1.bodyTargetType), typeCreators_1.createArgSuffixType('geoPosition', geoCoordinates_1.geoCoordinatesType), typeCreators_1.createArgSuffixType('position', vector_1.vectorType), typeCreators_1.createArgSuffixType('altitude', scalar_1.scalarType), typeCreators_1.createArgSuffixType('agl', scalar_1.scalarType), typeCreators_1.createArgSuffixType('nearSurface', boolean_1.booleanType), typeCreators_1.createArgSuffixType('grounded', boolean_1.booleanType), typeCreators_1.createArgSuffixType('index', scalar_1.scalarType), typeCreators_1.createArgSuffixType('clustered', boolean_1.booleanType));
//# sourceMappingURL=waypoint.js.map