/**
 * Flatten a set of nested arrays
 * @param arrays a collection of nested arrays
 */
export declare const flatten: <T>(arrays: T[][]) => T[];
/**
 * Zip two arrays together as an iterable of tuples. Note if array are unequal
 * then the shorter array is the stopping condition
 * @param arr1 first array
 * @param arr2 second array
 */
export declare function zip<T1, T2>(arr1: T1[], arr2: T2[]): IterableIterator<[T1, T2]>;
