"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const vscode_languageserver_1 = require("vscode-languageserver");
const constants_1 = require("./constants");
/**
 * This provides thin wrapper around Diagnostic.create where the server name is already included
 * @param range range the diagnostics applies
 * @param message message for the diagnostic
 * @param severity severity of the diagnostic
 * @param code error code
 * @param relatedInformation other related information
 */
exports.createDiagnostic = (range, message, severity, code, relatedInformation) => {
    return vscode_languageserver_1.Diagnostic.create(range, message, severity, code, constants_1.languageServer, relatedInformation);
};
//# sourceMappingURL=diagnosticsUtils.js.map