"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = require("fs");
const path_1 = require("path");
exports.readFileAsync = (path, encoding) => {
    return new Promise((resolve, reject) => {
        fs_1.readFile(path, { encoding }, (err, data) => {
            if (err) {
                reject(err);
            }
            resolve(data);
        });
    });
};
exports.walkDir = (dir, callback) => {
    fs_1.readdirSync(dir).forEach((f) => {
        const dirPath = path_1.join(dir, f);
        const isDirectory = fs_1.statSync(dirPath).isDirectory();
        isDirectory ?
            exports.walkDir(dirPath, callback) : callback(path_1.join(dir, f));
    });
};
//# sourceMappingURL=fsUtils.js.map