"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// dummy logger we may need for testing or just performance
exports.mockLogger = {
    level: 0 /* verbose */,
    error: (_) => { },
    warn: (_) => { },
    info: (_) => { },
    log: (_) => { },
    verbose: (_) => { },
};
exports.mockTracer = {
    log: (_, __) => { },
};
exports.consoleLogger = {
    level: 0 /* verbose */,
    error: (message) => console.error(message),
    warn: (message) => console.warn(message),
    info: (message) => console.info(message),
    log: (message) => console.log(message),
    verbose: (message) => console.log(message),
};
exports.consoleTracer = {
    log: (message, verbose) => console.trace(message, verbose),
};
// wrapper class for logger to implement logging levels
class Logger {
    constructor(connection, level) {
        this.connection = connection;
        this.level = level;
    }
    error(message) {
        if (this.level <= 4 /* error */) {
            this.connection.warn(message);
        }
    }
    warn(message) {
        if (this.level <= 3 /* warn */) {
            this.connection.warn(message);
        }
    }
    log(message) {
        if (this.level <= 2 /* log */) {
            this.connection.log(message);
        }
    }
    info(message) {
        if (this.level <= 1 /* info */) {
            this.connection.info(message);
        }
    }
    verbose(message) {
        if (this.level <= 0 /* verbose */) {
            this.connection.info(message);
        }
    }
}
exports.Logger = Logger;
//# sourceMappingURL=logger.js.map