"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typeGuards_1 = require("./typeGuards");
/**
 * memoize single parameter function
 * @param func function to memoize
 */
exports.memoize = (func) => {
    const memory = new Map();
    return (arg1) => {
        const result = memory.get(arg1);
        if (!typeGuards_1.empty(result))
            return result;
        const newResult = func(arg1);
        memory.set(arg1, newResult);
        return newResult;
    };
};
//# sourceMappingURL=memoize.js.map