import { Analyzer } from '../analyzer';
import { TextDocumentPositionParams, CompletionItem, DocumentSymbolParams, SymbolInformation, MessageReader, MessageWriter } from 'vscode-languageserver';
import { IServer } from '../server';
/**
 * Get the connection primitives based on the request connection type
 * @param connectionType connection type
 */
export declare const getConnectionPrimitives: (connectionType: string) => {
    writer: MessageWriter;
    reader: MessageReader;
};
/**
 * Get the connection primitives based on the request connection type
 * @param connectionType connection type
 */
export declare const updateServer: (server: IServer) => void;
/**
 * Get a list of all symbols currently in scope at the given line
 * @param analyzer analyzer instance
 * @param documentPosition the current position in the document
 * @param keywordCompletions a list of keywords to always concat
 */
export declare const symbolCompletionItems: (analyzer: Analyzer, documentPosition: TextDocumentPositionParams, keywordCompletions: CompletionItem[]) => CompletionItem[];
/**
 * Get a list of all known suffixes give a suffix completion trigger
 * @param analyzer analyzer instance
 * @param documentPosition the current position in the document
 */
export declare const suffixCompletionItems: (analyzer: Analyzer, documentPosition: TextDocumentPositionParams) => CompletionItem[];
/**
 * Get all symbols in the current document
 * @param analyzer analyzer instance
 * @param documentSymbol document identifier
 */
export declare const documentSymbols: (analyzer: Analyzer, documentSymbol: DocumentSymbolParams) => Maybe<SymbolInformation[]>;
